﻿XIncludeFile "..\..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

UsePNGImageDecoder() ; not really necessary ;-)

Enumeration
	#myWindow
	#ComboBoxTheme
	#ComboBoxRegular
	#ComboBoxEditable
	#ComboBoxImage
	#ComboBoxSimple
EndEnumeration

LoadImage(0, "table.png")
LoadImage(1, "user.png")
LoadImage(2, "world.png")

Procedure ComboBoxTheme_ChangeEvent()
	SetTheme(GetGadgetText(#ComboBoxTheme))
EndProcedure

OpenWindow(#myWindow, 0, 0, 290, 260, "ComboBoxGadget", #PB_Window_ScreenCentered)

TextGadget(#PB_Any, 10, 17, 120, 20, "Select a theme:")

ComboBoxGadget(#ComboBoxTheme, 130, 10, 150, 25)

AddGadgetItem(#ComboBoxTheme, -1, "black-tie")
AddGadgetItem(#ComboBoxTheme, -1, "blitzer")
AddGadgetItem(#ComboBoxTheme, -1, "cupertino")
AddGadgetItem(#ComboBoxTheme, -1, "dark-hive")
AddGadgetItem(#ComboBoxTheme, -1, "dot-luv")
AddGadgetItem(#ComboBoxTheme, -1, "eggplant")
AddGadgetItem(#ComboBoxTheme, -1, "excite-bike")
AddGadgetItem(#ComboBoxTheme, -1, "flick")
AddGadgetItem(#ComboBoxTheme, -1, "hot-sneaks")
AddGadgetItem(#ComboBoxTheme, -1, "humanity")
AddGadgetItem(#ComboBoxTheme, -1, "le-frog")
AddGadgetItem(#ComboBoxTheme, -1, "mint-choc")
AddGadgetItem(#ComboBoxTheme, -1, "overcast")
AddGadgetItem(#ComboBoxTheme, -1, "pepper-grinder")
AddGadgetItem(#ComboBoxTheme, -1, "redmond")
AddGadgetItem(#ComboBoxTheme, -1, "smoothness")
AddGadgetItem(#ComboBoxTheme, -1, "south-street")
AddGadgetItem(#ComboBoxTheme, -1, "start")
AddGadgetItem(#ComboBoxTheme, -1, "sunny")
AddGadgetItem(#ComboBoxTheme, -1, "swanky-purse")
AddGadgetItem(#ComboBoxTheme, -1, "trontastic")
AddGadgetItem(#ComboBoxTheme, -1, "ui-darkness")
AddGadgetItem(#ComboBoxTheme, -1, "ui-lightness")
AddGadgetItem(#ComboBoxTheme, -1, "vader")

SetGadgetState(#ComboBoxTheme, 15)

; SetGadgetAttribute(#ComboBoxTheme, #PB_ComboBox_MaxHeight, @"100px")

BindGadgetEvent(#ComboBoxTheme, @ComboBoxTheme_ChangeEvent(), #PB_EventType_Change)

; Editable ComboBox
ComboBoxGadget(#ComboBoxEditable, 10, 60, 270, 25, #PB_ComboBox_Editable)
For a = 1 To 5
	AddGadgetItem(#ComboBoxEditable, -1, "ComboBox editable Item " + Str(a))
Next

; ResizeImage(0, 32, 32)

; ComboBox with images
ComboBoxGadget(#ComboBoxImage, 10, 110, 270, 25, #PB_ComboBox_Image)
AddGadgetItem(#ComboBoxImage, -1, "ComboBox Image Item 1", ImageID(0))
AddGadgetItem(#ComboBoxImage, -1, "ComboBox Image Item 2", ImageID(1))
AddGadgetItem(#ComboBoxImage, -1, "ComboBox Image Item 3", ImageID(2))

; regular ComboBox
ComboBoxGadget(#ComboBoxRegular, 10, 160, 270, 25)
For a = 1 To 5
	AddGadgetItem(#ComboBoxRegular, -1, "ComboBox Item " + Str(a))
Next

; simple ComboBox
ComboBoxGadget(#ComboBoxSimple, 10, 210, 270, 25, #PB_ComboBox_Simple)
For a = 1 To 5
	AddGadgetItem(#ComboBoxSimple, -1, "ComboBox Item " + Str(a))
Next

SetGadgetState(#ComboBoxEditable, 0)
SetGadgetState(#ComboBoxImage, 0)
SetGadgetState(#ComboBoxRegular, 2) ; set (beginning with 0) the third item as active one

; ! $("#g_" + ComboBoxRegular).selectmenu( "open" ); 

DataSection
	IncludeBinary "table.png"
	IncludeBinary "user.png"
	IncludeBinary "world.png"
EndDataSection


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 92
; FirstLine = 49
; Folding = 0
; EnableUnicode
; EnableXP