XIncludeFile "..\..\p2w.pbi"

P2W_Converter_SetProfile("DesktopApp")

EnableCGI

ProcedureDLL CreateLoremIpsum()
	
	Protected FF
	Protected ReturnValue = #False
	
	FF = CreateFile(#PB_Any, "LoremIpsum.txt")
	
	If FF
		WriteStringN(FF, "Lorem ipsum dolor sit amet, consetetur sadipscing elitr...")
		CloseFile(FF)
		ReturnValue = #True
	EndIf
	
	ProcedureReturn ReturnValue

EndProcedure

ProcedureDLL.s ReadLoremIpsum()
	
	Protected FF
	Protected ReturnValue.s
	
	FF = ReadFile(#PB_Any, "LoremIpsum.txt")
	
	If FF
		ReturnValue = ReadString(FF)
		CloseFile(FF)
	Else
		ReturnValue = "Couldn't read file"
	EndIf
	
	ProcedureReturn ReturnValue

EndProcedure

DisableCGI

Enumeration
	#Desktop
	#ListIconGadget
EndEnumeration

OpenWindow(#Desktop, 0, 0, 0, 0, "", #PB_Window_BorderLess | #PB_Window_Maximize)

ListIconGadget(#ListIconGadget, 10, 10, WindowWidth(#Desktop) - 200, 200, "Column1", 100)
AddGadgetColumn(#ListIconGadget, 1, "Column2", 100)
AddGadgetColumn(#ListIconGadget, 2, "Column3", 100)

AddGadgetItem(#ListIconGadget, -1, "This")
AddGadgetItem(#ListIconGadget, -1, #LF$ + "is a")
AddGadgetItem(#ListIconGadget, -1, #LF$ + #LF$ + "test")

Define i.s, val.s

Debug "Browser informations:"

!jQuery.each( jQuery.browser, function( i, val ) {
	Debug i + ": " + val
!});

Debug "Some CGI-Tests..."

Debug "Try to create 'LoremIpsum.txt'..."

If CreateLoremIpsum()
	
	Debug "... sucess :-)"
	
	Debug "Try to read 'LoremIpsum.txt'..."
	
	Debug "Result: " + ReadLoremIpsum()
	
Else
	
	Debug "... failed :-("
	
EndIf

Define Counter

For Counter = 0 To 100
	Debug ElapsedMilliseconds()
Next

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 83
; FirstLine = 40
; Folding = -
; EnableXP
; Executable = ..\..\DesktopApp\DesktopApp.exe