﻿; lorempixel

EnableExplicit

XIncludeFile "LoremPixel.pbf"

XIncludeFile "..\p2w.pbi"

Enumeration FormWindow
	#Desktop
EndEnumeration

Enumeration FormGadget
	#imgImage
EndEnumeration

Procedure ImageLoaded()
	
	DisableWindow(#frmMain, #False)
	
	SetGadgetState(#imgImage, ImageID(0))
	
	; center image on desktop:
	
	ResizeGadget(#imgImage,
	             (WindowWidth(#Desktop) - GadgetWidth(#imgImage)) / 2, 
	             (WindowHeight(#Desktop) - GadgetHeight(#imgImage)) / 2,
	             #PB_Ignore, #PB_Ignore)
	
EndProcedure

Procedure ButtonEvent()
	
	Protected Width = GetGadgetState(#trkWidth)
	Protected Height = GetGadgetState(#trkHeight)
	
	Protected URL.s = "http://lorempixel.com/"
	
	If GetGadgetState(#chkGray)
		URL + "g/"
	EndIf
	
	URL + Str(Width) + "/" + Str(Height) + "/"
	
	If GetGadgetState(#cboCategory) > 0
		URL + GetGadgetText(#cboCategory) + "/"
	EndIf
	
	URL + "?rnd=" + Str(ElapsedMilliseconds())
	
	DisableWindow(#frmMain, #True)
	
	LoadImage(0, URL, 0, @ImageLoaded())
	
EndProcedure

! function getTextWidth(text, font) {
!     // re-use canvas object for better performance
!     var canvas = getTextWidth.canvas || (getTextWidth.canvas = document.createElement("canvas"));
!     var context = canvas.getContext("2d");
!     context.font = font;
!     var metrics = context.measureText(text);
!     return metrics.width;
! };

Procedure.s formatFloat(element, val)
	
	Protected w
	
	! w = getTextWidth( val + "px", "bold 12pt arial");
	! w2 = w / 2;
	
 	! $(element).find(".ui-slider-tip").css("width", w + "px");
 	! $(element).find(".ui-slider-tip").css("margin-left", "-" + w2 + "px");
	
	ProcedureReturn Str(val) + "px"
	
EndProcedure

OpenWindow(#Desktop, 0, 0, 0, 0, "LoremPixel-Demo", #PB_Window_BorderLess | #PB_Window_Maximize)

ImageGadget(#imgImage, 0, 0, -1, -1, 0)

OpenfrmMain()

SetGadgetState(#cboCategory, 0)

SetGadgetAttribute(#trkWidth, #PB_TrackBar_Maximum, WindowWidth(#Desktop))
SetGadgetAttribute(#trkHeight, #PB_TrackBar_Maximum, WindowHeight(#Desktop))

SetGadgetState(#trkWidth, 800)
SetGadgetState(#trkHeight, 600)

! $("#g_" + trkWidth).slider('float', { formatLabel: function (val) { return formatFloat("#g_" + trkWidth, val) } });
! formatFloat("#g_" + trkWidth, 9999)

! $("#g_" + trkHeight).slider('float', { formatLabel: function (val) { return formatFloat("#g_" + trkHeight, val) } });
! formatFloat("#g_" + trkHeight, 9999)

BindGadgetEvent(#cmdGetImage, @ButtonEvent())


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 8
; Folding = -
; EnableUnicode
; EnableXP