XIncludeFile "..\p2w.pbi"

Enumeration
  #myWindow
  #myMenu
  #mnuOpen
  #mnuSubFile1
  #mnuSubFile2
  #mnuSave
  #mnuSaveAs
  #mnuQuit
  #mnuOptions
  #FileIcon
EndEnumeration

Procedure mnuEvent()
  
  Select EventMenu()
    Case #mnuOpen     : Debug "MenuEvent: Open"
    Case #mnuSubFile1 : Debug "MenuEvent: File1"
    Case #mnuSubFile2 : Debug "MenuEvent: File2"
    Case #mnuSave     : Debug "MenuEvent: Save"
    Case #mnuSaveAs   : Debug "MenuEvent: Save as"
    Case #mnuQuit     : Debug "MenuEvent: Quit"
    Case #mnuOptions  : Debug "MenuEvent: Options"
  EndSelect
  
EndProcedure

LoadImage(#FileIcon, "page_white_text.png")

OpenWindow(#myWindow, 200, 200, 500, 300, "Menu Example", #PB_Window_ScreenCentered)

CreateMenu(#myMenu, WindowID(#myWindow))

MenuTitle("Project")
MenuItem(#mnuOpen, "Open", @"ui-icon-folder-open") ; custom icon. see: http://api.jqueryui.com/theming/icons/
OpenSubMenu("Recent files", #FileIcon)
MenuItem(#mnuSubFile1, "File1", #FileIcon)
MenuItem(#mnuSubFile2, "File2", #FileIcon)
CloseSubMenu()
MenuItem(#mnuSave, "Save", @"ui-icon-disk")
MenuItem(#mnuSaveAs, "Save as", @"ui-icon-disk")
MenuBar()
MenuItem(#mnuQuit, "Quit")
MenuTitle("Extras")
MenuItem(#mnuOptions, "Options", @"ui-icon-wrench")

BindMenuEvent(#myMenu, #mnuOpen,     @mnuEvent())
BindMenuEvent(#myMenu, #mnuSubFile1, @mnuEvent())
BindMenuEvent(#myMenu, #mnuSubFile2, @mnuEvent())
BindMenuEvent(#myMenu, #mnuSave,     @mnuEvent())
BindMenuEvent(#myMenu, #mnuSaveAs,   @mnuEvent())
BindMenuEvent(#myMenu, #mnuQuit,     @mnuEvent())
BindMenuEvent(#myMenu, #mnuOptions,  @mnuEvent())

DataSection
	IncludeBinary "page_white_text.png"
EndDataSection
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 15
; Folding = -
; EnableXP