XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

Structure sPerson
	Firstname.s
	Lastname.s
EndStructure

Global NewList Persons.sPerson()

Procedure onSuccess(ReceivedData.s)
	
	; MessageRequester("", ReceivedData)
	
	ParseJSON(0, ReceivedData)
	
	ExtractJSONList(JSONValue(0), Persons())
	
	ForEach Persons()
		
		Debug Persons()\Firstname
		Debug Persons()\Lastname
		Debug "---"
		
	Next
	
EndProcedure

Procedure onError(a.s, b.s, c.s)
	
	MessageRequester("P2W_HttpRequest_JSON", b + " / " + c)
	
EndProcedure

Define *Person.sPerson

*Person = AddElement(Persons())
*Person\Firstname = "Bruce"
*Person\Lastname = "Wayne"

*Person = AddElement(Persons())
*Person\Firstname = "Clark"
*Person\Lastname = "Kent"

CreateJSON(0)

InsertJSONList(JSONValue(0), Persons())

Define la = ListData(Persons())

P2W_HttpRequest("P2W_HttpRequest_JSON.php", "POST", ComposeJSON(0), "", #False, @onSuccess(), @onError())

DataSection
	
	IncludeBinary "P2W_HttpRequest_JSON.php"
	
EndDataSection

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; Folding = -
; EnableXP