﻿EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\GoogleMapGadget\GoogleMapGadget.pbi"

#myWindow    = 0
#myGoogleMap = 0
#myTimer = 0

P2W_Converter_SetProfile("pb2webtest")

Global IsRed = #False

; more icons: https://sites.google.com/site/gmapsdevelopment/
Global BlueDot = LoadImage(#PB_Any, "http://maps.google.com/mapfiles/ms/icons/blue-dot.png")
Global RedDot  = LoadImage(#PB_Any, "http://maps.google.com/mapfiles/ms/icons/red-dot.png")

Procedure TimerEvent()
	If IsRed 
		SetGadgetItemImage(#myGoogleMap, 1, ImageID(BlueDot))
		IsRed = #False
	Else
		SetGadgetItemImage(#myGoogleMap, 1, ImageID(RedDot))
		IsRed = #True
	EndIf
EndProcedure

OpenWindow(#myWindow, 10, 10, 660, 500, "GoogleMapTest")
	
; ------

GoogleMapGadget(#myGoogleMap, 10, 10, 640, 480)
	
SetGadgetAttribute(#myGoogleMap, #GoogleMapType, #GoogleMapTypeSatellite)
SetGadgetAttribute(#myGoogleMap, #GoogleMapZoom, 18)

; ----

AddGadgetItem(#myGoogleMap, -1, "52.516, 13.371", BlueDot)
AddGadgetItem(#myGoogleMap, -1, "52.517, 13.371", BlueDot)
AddGadgetItem(#myGoogleMap, -1, "52.518, 13.371", BlueDot)

; ----

SetGadgetAttribute(#myGoogleMap, #GoogleMapBounds, 0) ; the last parameter is a dummy-value
	
AddWindowTimer(#myWindow, #myTimer, 500)
BindEvent(#PB_Event_Timer, @TimerEvent(), #myWindow, #myTimer)




; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableUnicode
; EnableXP