; Global P2W_Start

; Important: Do not change this file!

Macro P2W_Converter_Begin_Comment
EndMacro
Macro P2W_Converter_End_Comment
EndMacro

P2W_Converter_Begin_Comment
	
Macro EnableJS
EndMacro
Macro DisableJS
EndMacro
	
Macro EnableCGI
EndMacro
Macro DisableCGI
EndMacro
	
Macro EnablePHP
EndMacro
Macro DisablePHP
EndMacro
	
Macro EnableNodeJs
EndMacro
Macro DisableNodeJs
EndMacro

Macro EnablePython
EndMacro
Macro DisablePython
EndMacro

Macro EnableASP
EndMacro
Macro DisableASP
EndMacro

Macro EnableASPX
EndMacro
Macro DisableASPX
EndMacro

Macro UseFontAwesome()
EndMacro
	
Macro UseBootstrap()
EndMacro
	
Macro UseCordova()
EndMacro
	
Macro UsePDF()
EndMacro
	
Macro UseMobile()
EndMacro
	
Macro EnableGadgetsAutoBind(GadgetsEventsCallback)
EndMacro
	
	Macro DisableGadgetsAutoBind()
	EndMacro
	
	Macro EnableWindowsAutoBind(WindowsEventsCallback)
	EndMacro
	Macro DisableWindowsAutoBind()
	EndMacro
	
	Macro P2W_Converter_SetProfile(ProfileName)
	EndMacro
	Macro P2W_Converter_AddHtmlHeadItem(Item)
	EndMacro
	Macro P2W_Converter_DoNotCopy()
	EndMacro
	Macro P2W_HttpRequest(URL, xType, xData, xDataType, xSync, onSuccess, onError, AdditionalParameter = 0)
	EndMacro
	Macro P2W_SetConfig(ParamName, ParamValue)
	EndMacro
	Macro SetGadgetCursor(Gadget, Cursor)
	EndMacro
	
	Macro SetGadgetCss(Gadget, CssName, CssValue)
	EndMacro
	Macro GetGadgetCss(Gadget, CssName)
	EndMacro
	
	Macro SetGadgetAttr(Gadget, AttrName, AttrValue)
	EndMacro
	Macro GetGadgetAttr(Gadget, AttrName)
	EndMacro
	Macro RemoveGadgetAttr(Gadget, AttrName)
	EndMacro
	
	Macro RemoveGadgetClass(Gadget, ClassName)
	EndMacro
	Macro AddGadgetClass(Gadget, ClassName)
	EndMacro
	Macro GetGadgetClass(Gadget, ClassName)
	EndMacro
	Macro SwitchGadgetClass(Gadget, RemoveClassName, AddClassName)
	EndMacro
	
	Enumeration
		
		#P2W_Config_ApplicationName
		#P2W_Config_ServerAddress
		#P2W_Config_TargetFolder
		
		#P2W_Config_AspFilename
		#P2W_Config_AspAddress
		#P2W_Config_AspxFilename
		#P2W_Config_AspxAddress
		#P2W_Config_CgiFilename
		#P2W_Config_CgiAddress
		#P2W_Config_PhpFilename
		#P2W_Config_PhpAddress
		#P2W_Config_NodeJsFilename
		#P2W_Config_NodeJsAddress
		
		#P2W_Config_PythonFilename
		#P2W_Config_PythonAddress
		#P2W_Config_UseFlask
		#P2W_Config_FlaskPort
		
	EndEnumeration
	
	Procedure SetBodyColor(Color)
	EndProcedure
		
	Procedure P2W_Alert(Message.s)
	EndProcedure
	
	Procedure P2W_IsValidMailAddress(MailAddress.s)
	EndProcedure
		
	Procedure Deb(Deb.s)
	EndProcedure
	Procedure P2W_ParseJSON(String.s)
	EndProcedure
	Procedure.s P2W_GetJSONValue(JSON, Attribute.s)
	EndProcedure
	Procedure.s P2W_RunFunction(FunctionName.s, FunctionParams.s)
	EndProcedure
	Procedure.s P2W_EvalFunction(FunctionName.s, FunctionParams.s)
	EndProcedure
	Procedure P2W_Geolocation_GetCurrentPosition(onSucces, onError)
	EndProcedure
	
	Procedure BindNetworkEvent(Websocket, Callback, EventType)
	EndProcedure
	
	Procedure SendWebsocket(Websocket, DataToSend)
	EndProcedure
	Procedure OpenWebsocket(URL.s)
	EndProcedure
	Procedure CloseWebsocket(Websocket, Code.s = "", Reason.s = "")
	EndProcedure
	
	Procedure CameraRequester(Title.s, Callback = 0)
	EndProcedure
	
	; Movie
	
	Procedure P2W_BindMovieEvent(Movie, Callback, EventType = #PB_All)
	EndProcedure
	Procedure P2W_SetMovieAttribute(Movie, Attribute, Value)
	EndProcedure
	Procedure P2W_GetMovieAttribute(Movie, Attribute)
	EndProcedure
	
	; Music
	
	Procedure P2W_BindMusicEvent(Music, Callback, EventType = #PB_All)
	EndProcedure
	Procedure P2W_SetMusicAttribute(Music, Attribute, Value)
	EndProcedure
	Procedure P2W_GetMusicAttribute(Music, Attribute)
	EndProcedure
	Procedure P2W_PauseMusic(Music)
	EndProcedure
	
	; 
	
	Procedure P2W_SaveText(Text.s, Filename.s)
	EndProcedure
	Procedure P2W_SaveCsv(Csv.s, Filename.s)
	EndProcedure
	Procedure P2W_SaveCanvas(CanvasGadget, Filename.s)
	EndProcedure
	
	; Sprite
	
	Procedure P2W_CreateStage(Color)
	EndProcedure
	Procedure P2W_CreateSprite(Filename.s)
	EndProcedure
	Procedure P2W_AddStageChild(Stage, Sprite)
	EndProcedure
	Procedure P2W_RenderGadget(Gadget, x, y, Width, Height)
	EndProcedure
	Procedure P2W_AnchorSprite(Sprite, x, y)
	EndProcedure
	Procedure P2W_RequestAnimFrame(Callback)
	EndProcedure
	Procedure P2W_RenderStage(Renderer, Stage)
	EndProcedure
	
	; LocalStorage
	
	Procedure P2W_LocalStorage_Available()
	EndProcedure
	Procedure.s P2W_LocalStorage_GetItem(Key.s, DefaultValue.s = "")
	EndProcedure
	Procedure P2W_LocalStorage_SetItem(Key.s, Value.s)
	EndProcedure
	Procedure P2W_LocalStorage_RemoveItem(Key.s)
	EndProcedure
	Procedure P2W_LocalStorage_GetTTL(Key.s)
	EndProcedure
	Procedure P2W_LocalStorage_SetTTL(Key.s, TTL)
	EndProcedure
	Procedure P2W_LocalStorage_ListenKeyChange(Key.s, Callback)
	EndProcedure
	Procedure P2W_LocalStorage_StopListening(Key.s)
	EndProcedure
	Procedure P2W_LocalStorage_Clear()
	EndProcedure
	
	; --
	
	Procedure P2W_IsMobile()
	EndProcedure
	
	Procedure P2W_Image2DataURL(URL.s, SuccessCallback, ErrorCallback)
	EndProcedure
	
	; --
	
	Procedure P2W_JQO_FromWindow(Window)
	EndProcedure
	Procedure P2W_JQO_FromGadget(Gadget)
	EndProcedure
	Procedure P2W_JQO_FromImage(Image)
	EndProcedure
	Procedure P2W_JQO_AddClass(JQueryObject, ClassName.s)
	EndProcedure
	Procedure P2W_JQO_HasClass(JQueryObject, ClassName.s)
	EndProcedure
	Procedure P2W_JQO_RemoveClass(JQueryObject, ClassName.s)
	EndProcedure
	Procedure P2W_JQO_ToggleClass(JQueryObject, ClassName.s)
	EndProcedure
	Procedure P2W_JQO_CSS(JQueryObject, PropertyName.s, PropertyValue.s)
	EndProcedure
	Procedure P2W_JQO_SetAttribute(JQueryObject, AttributeName.s, AttributeValue.s)
	EndProcedure
	Procedure P2W_JQO_GetAttribute(JQueryObject, AttributeName.s, AttributeValue.s)
	EndProcedure
	Procedure P2W_JQO_RemoveAttribute(JQueryObject, AttributeName.s, AttributeValue.s)	
	EndProcedure
	
	Procedure.s P2W_EvalS(JavaScriptString.s)
	EndProcedure
	Procedure P2W_EvalN(JavaScriptString.s)
	EndProcedure
	
	Procedure P2W_SetDesktopID(DesktopID)
	EndProcedure
	Procedure P2W_GetDesktopID()
	EndProcedure
	
	Procedure P2W_BlockWindow(Window, State, Message.s = "", Title.s = "", Callback = 0)
	EndProcedure
	Procedure P2W_BlockGadget(Gadget, State, Message.s = "", Title.s = "", Callback = 0)
	EndProcedure
	
	Procedure.s P2W_Base64Decoder(Input.s)
	EndProcedure
	Procedure.s P2W_Base64Encoder(Input.s)
	EndProcedure
	
	Procedure P2W_SetCookie(Name.s, Value.s, Expires=0)
	EndProcedure
	Procedure.s P2W_GetCookie(Name.s)
	EndProcedure
	Procedure P2W_RemoveCookie(Name.s)
	EndProcedure
	Procedure P2W_CookieExists(Name.s)
	EndProcedure
	
	
	; // Mobile-Lib
; 	Procedure NewPage(Title.s)
; 	EndProcedure
; 	Procedure NewWidget(WidgetType.s, ParentWidget = 0)
; 	EndProcedure
; 	Procedure AppendWidget(ParentWidget, ChildWidget)
; 	EndProcedure
; 	Procedure   SetWidgetText(Widget, Text.s)
; 	EndProcedure
; 	Procedure.s GetWidgetText(Widget)
; 	EndProcedure
; 	Procedure   SetWidgetItemText(Widget, Position, Text.s, Column = 0)
; 	EndProcedure
; 	Procedure.s GetWidgetItemText(Widget, Position, Column = 0)
; 	EndProcedure
; 	Procedure SetWidgetAttribute(Widget, Attribute, Value)
; 	EndProcedure
; 	Procedure.s GetWidgetAttribute(Widget, AttributeName.s)
; 	EndProcedure
; 	Procedure RemoveWidgetAttribute(Widget, AttributeName.s)
; 	EndProcedure
; 	Procedure AddWidgetClass(Widget, Classname.s)
; 	EndProcedure
; 	Procedure RemoveWidgetClass(Widget, Classname.s)
; 	EndProcedure
; 	Procedure GetWidgetState(Gadget)
; 	EndProcedure
; 	Procedure SetWidgetState(Gadget, State)
; 	EndProcedure
; 	Procedure OpenPage(Page, Transition.s = "", Reverse = #False)
; 	EndProcedure
; 	Procedure ClosePage(Page)
; 	EndProcedure
; 	Procedure FreeWidget(Widget)
; 	EndProcedure
; 	Procedure ShowLoading(State)
; 	EndProcedure
	Procedure NewPDF(orientation.s = "portrait")
	EndProcedure
	Procedure PdfSetFont(doc, font.s) 
	EndProcedure
	Procedure PdfSetFontType(doc, fonttype.s) 
	EndProcedure
	Procedure PdfSetFontSize(doc, fontsize) 
	EndProcedure
	Procedure PdfAddEllipse(doc, x, y, rx, ry, style.s= "") 
	EndProcedure
	Procedure PdfAddCircle(doc, x, y, r, style.s= "") 
	EndProcedure
	Procedure PdfSetFillColor(doc, r, g, b) 
	EndProcedure
	Procedure PdfSetLineWidth(doc, w) 
	EndProcedure
	Procedure PdfSetDrawColor(doc, r, g, b) 
	EndProcedure
	Procedure PdfSetTextColor(doc, r, g, b) 
	EndProcedure
	Procedure PdfAddLine(doc, x1, y1, x2, y2) 
	EndProcedure
	Procedure PdfAddRect(doc, x, y, w, h, style.s= "") 
	EndProcedure
	Procedure PdfAddTriangle(doc, x1, y1, x2, y2, x3, y3, style.s= "") 
	EndProcedure
	Procedure PdfAddRoundedRect(doc, x, y, w, h, rx, ry, style.s= "") 
	EndProcedure
	Procedure PdfAddImage(doc, imgData.s, imgType.s, x, y, w, h) 
	EndProcedure
	Procedure PdfAddText(doc, x, y, text.s) 
	EndProcedure
	Procedure PdfAddPage(doc) 
	EndProcedure
	Procedure.s PdfOutput(doc) 
	EndProcedure
	Procedure ListData(AnyLinkedList)
	EndProcedure
	Procedure BindGadgetItemEvent(Gadget, Item, Callback, EventType = 0)
	EndProcedure
	Procedure DeleteDatabase(Databasename.s)
	EndProcedure
	Procedure.s XSLTransformation(XML.s, XSL.s)
	EndProcedure
	Procedure ExternalRaiseEvent(EventName.s, Params.s)
	EndProcedure
	Procedure WebSpeech_Start(Continuous, InterimResults, Language.s = "en-GB", onStartCallback = 0, onErrorCallback = 0, onEndCallback = 0, onResultCallback = 0)
	EndProcedure
	Procedure WebSpeech_Stop()
	EndProcedure
	Procedure Split(String.s, Separator.s, Count = 0)
	EndProcedure
	Procedure.s Join(JoinArray, Separator.s="")
	EndProcedure
	Procedure.s GetBrowserLanguage()
	EndProcedure
	Procedure   SetBrowserLanguage(Language.s)
	EndProcedure
	Procedure   SetGuiSize(Size.s)
	EndProcedure
	Procedure.s GetGuiSize()
	EndProcedure	
	Procedure SetTheme(Theme.s)
	EndProcedure
	Procedure RegisterUserGadgetProcedure(Gadget.s, Procedurename.s, ProcedureAddress)
	EndProcedure
		
	Procedure BindKeyboardShortcut(Object, Key, Callback, EventMenu, EventType = 0)
	EndProcedure
	Procedure EnableGadgetDrag(Gadget, State, Options = #Null)
	EndProcedure
	
	Procedure EventDragGadget() : EndProcedure
	Procedure EventDragX() : EndProcedure
	Procedure EventDragY() : 	EndProcedure
	
	Procedure EventDropGadget() : EndProcedure
	
	Procedure.s GetGadgetHtml(Gadget)
	EndProcedure
	Procedure   SetGadgetHtml(Gadget, Html.s)
	EndProcedure
	
	Procedure IsWindowTimer(Window, Timer)
	EndProcedure
	
	Procedure SetWindowBackgroundImage(Window, Image.s)
	EndProcedure
		
	; --------------------------
	
	Procedure.s GetGadgetCsv(Gadget, IncludeHeader = #True, FieldDelimiter.s = ";", TextDelimiter.s = #DQUOTE$)
	EndProcedure
	
	; --------------------------
	
	Procedure GridGadget(Gadget, x, y, Width, Height, Header.s = "", Flags = 0)
	EndProcedure
	
	Procedure HtmlGadget(Gadget, x, y, Width, Height, Html.s)
	EndProcedure
	
	Procedure IFrameGadget(Gadget, x, y, Width, Height)
	EndProcedure
	
	Procedure.s LoadTextfile(Filename.s)
	EndProcedure
	
	Procedure P2W_SetEditorLanguage(Language.s)
	EndProcedure
	
	Procedure P2W_SetEditorPlugins(Plugins.s)
	EndProcedure
	
	Procedure P2W_SetEditorMenuBar(MenuBar.s)
	EndProcedure
	
	Procedure P2W_SetEditorToolBar(ToolBar.s)
	EndProcedure
	
	Procedure P2W_SetEditorStatusBar(StatusBar)
	EndProcedure
	
	Procedure P2W_SetEditorPdfFilename(PdfFilename.s)
	EndProcedure
	
	Procedure Moment(Moment = 0)
	EndProcedure
	
	Procedure AddMoment(Date, Type.s, Value)
	EndProcedure
	
	Procedure.s FormatMoment(Mask.s, Date)
	EndProcedure
	
	Procedure ParseMoment(Mask.s, Date.s)
	EndProcedure
	
	Procedure MomentFromDate(Date)
	EndProcedure
	
	Procedure DateFromMoment(Moment)
	EndProcedure
	
	Procedure CenterWindow(Window)
	EndProcedure
		
	Procedure __LoadMovie(Movie.i, Filename.s, Callback)
		Protected result.i
		result = LoadMovie(Movie, Filename)
		ProcedureReturn result
	EndProcedure
	Macro LoadMovie(Movie, Filename, Callback = 0)
		__LoadMovie(Movie, Filename, Callback)
	EndMacro
	
	Procedure __LoadMusic(Music.i, Filename.s, Callback)
		Protected result.i
		result = LoadMusic(Music, Filename)
		ProcedureReturn result
	EndProcedure
	Macro LoadMusic(Music, Filename, Callback = 0)
		__LoadMusic(Music, Filename, Callback)
	EndMacro
	
	Procedure __MessageRequester(Title.s, Text.s, Flags, Callback)
		Protected result.i
		result = MessageRequester(Title, Text, Flags)
		ProcedureReturn result
	EndProcedure
	Macro MessageRequester(Title, Text, Flags = 0, Callback = 0)
		__MessageRequester(Title, Text, Flags, Callback)
	EndMacro
	
	Procedure __LoadImage(Image, Filename.s, Flags, Callback)
		Protected result.i
		result = LoadImage(Image, Filename, Flags)
		ProcedureReturn result	
	EndProcedure
	Macro LoadImage(Image, Filename, Flags = 0, Callback = 0)
		__LoadImage(Image, Filename, Flags, Callback)
	EndMacro
	
	Procedure.s __OpenFileRequester2(Title.s, DefaultFile.s, Pattern.s, PatternPosition, Flags, Callback)
		Protected result.s
		result = OpenFileRequester(Title, DefaultFile, Pattern, PatternPosition, Flags)
		ProcedureReturn result
	EndProcedure
	Macro OpenFileRequester2(Title, DefaultFile, Pattern, PatternPosition, Flags = 0, Callback = 0)
		__OpenFileRequester2(Title, DefaultFile, Pattern, PatternPosition, Flags, Callback)
	EndMacro
	
	Procedure.s __OpenFileRequester(Title.s, DefaultFile.s, Pattern.s, PatternPosition, Flags, Callback)
		Protected result.s
		result = OpenFileRequester(Title, DefaultFile, Pattern, PatternPosition, Flags)
		ProcedureReturn result
	EndProcedure
	Macro OpenFileRequester(Title, DefaultFile, Pattern, PatternPosition, Flags = 0, Callback = 0)
		__OpenFileRequester(Title, DefaultFile, Pattern, PatternPosition, Flags, Callback)
	EndMacro
	
	Procedure.s __SaveFileRequester(Title.s, DefaultFile.s, Pattern.s, PatternPosition, Callback)
		Protected result.s
		result = SaveFileRequester(Title, DefaultFile, Pattern, PatternPosition)
		ProcedureReturn result
	EndProcedure
	Macro SaveFileRequester(Title, DefaultFile, Pattern, PatternPosition, Callback = 0)
		__SaveFileRequester(Title, DefaultFile, Pattern, PatternPosition, Callback)
	EndMacro
	
	Procedure __HideGadget(Gadget, State, Duration = 0, Callback = 0)
		HideGadget(Gadget, State)
	EndProcedure
	Macro HideGadget(Gadget, State, Duration = 0, Callback = 0)
		__HideGadget(Gadget, State, Duration, Callback)
	EndMacro
	
	Procedure __HideWindow(Window, State, Flags = 0, Duration = 0, Callback = 0)
		HideWindow(Window, State, Flags)
	EndProcedure
	Macro HideWindow(Window, State, Flags = 0, Duration = 0, Callback = 0)
		__HideWindow(Window, State, Flags, Duration, Callback)
	EndMacro
	
	Procedure __SetGadgetState(Gadget, State, Callback = 0)
		SetGadgetState(Gadget, State)
	EndProcedure
	Macro SetGadgetState(Gadget, State, Callback = 0)
		__SetGadgetState(Gadget, State, Callback)
	EndMacro
	
	Procedure __OpenLibrary(Library, Filename.s, SuccessCallback = 0, ErrorCallback = 0)
		ProcedureReturn OpenLibrary(Library, Filename)
	EndProcedure
	Macro OpenLibrary(Library, Filename, SuccessCallback = 0, ErrorCallback = 0)
		__OpenLibrary(Library, Filename, SuccessCallback, ErrorCallback)
	EndMacro
	
	Procedure __ColorRequester(Color, Callback = 0)
		ColorRequester(Color)
	EndProcedure
	Macro ColorRequester(Color, Callback = 0)
		__ColorRequester(Color, Callback)
	EndMacro	
	
	Procedure __PanelGadget(Gadget, x, y, Width, Height, Flags = 0)
		Protected Result
		Result = PanelGadget(Gadget, x, y, Width, Height)
		ProcedureReturn Result
	EndProcedure
	Macro PanelGadget(Gadget, x, y, Width, Height, Flags = 0)
		__PanelGadget(Gadget, x, y, Width, Height, Flags)
	EndMacro
	
	Procedure __EditorGadget(Gadget, x, y, Width, Height, Flags = 0, Callback = 0)
		Protected Result
		Result = EditorGadget(Gadget, x, y, Width, Height, Flags)
		ProcedureReturn Result
	EndProcedure
	Macro EditorGadget(Gadget, x, y, Width, Height, Flags = 0, Callback = 0)
		__EditorGadget(Gadget, x, y, Width, Height, Flags, Callback)
	EndMacro
	
	Procedure __AddGadgetItem(Gadget, Position, Text.s, ImageID, Flags)
		Protected Result
		Result = AddGadgetItem(Gadget, Position, Text, ImageID, Flags)
		ProcedureReturn Result
	EndProcedure
	Macro AddGadgetItem(Gadget, Position, Text = "", ImageID = 0, Flags = 0)
		__AddGadgetItem(Gadget, Position, Text, ImageID, Flags)
	EndMacro
	
	Procedure.s __GetGadgetText(Gadget, Attribute)
		Protected Result.s
		Result = GetGadgetText(Gadget)
		ProcedureReturn Result
	EndProcedure
	Macro GetGadgetText(Gadget, Attribute = 0)
		__GetGadgetText(Gadget, Attribute)
	EndMacro	
	
	Procedure __CloseDatabase(Database, Save)
		CloseDatabase(Database)
	EndProcedure
	Macro CloseDatabase(Database, Save = #True)
		__CloseDatabase(Database, Save)
	EndMacro		
	
	Procedure.s __InputRequester(Title.s, Message.s, DefaultText.s, Flags = 0, Callback = 0)
		Protected Result.s
		Result = InputRequester(Title, Message, DefaultText, Flags)
		ProcedureReturn Result
	EndProcedure
	Macro InputRequester(Title, Message, DefaultText, Flags = 0, Callback = 0)
		__InputRequester(Title, Message, DefaultText, Flags, Callback)
	EndMacro
	
	Procedure __LoadXML(XML, Filename.s, Encoding = #PB_UTF8, Callback = 0)
		Protected Result
		Result = LoadXML(XML, Filename, Encoding)
		ProcedureReturn Result
	EndProcedure
	Macro LoadXML(XML, Filename, Encoding = #PB_UTF8, Callback = 0)
		__LoadXML(XML, Filename, Encoding, Callback)
	EndMacro	
	
	Procedure __GetGadgetData(Gadget, Key.s)
		GetGadgetData(Gadget)
	EndProcedure
	Macro GetGadgetData(Gadget, Key)
		__GetGadgetData(Gadget, Key)
	EndMacro
	
	Procedure __SetGadgetData(Gadget, Key.s, Value)
		SetGadgetData(Gadget, Value)
	EndProcedure
	Macro SetGadgetData(Gadget, Key, Value)
		__SetGadgetData(Gadget, Key, Value)
	EndMacro
	
	Procedure __ReceiveHTTPMemory(Url.s, Flags, Callback)
		ReceiveHTTPMemory(Url, Flags)
	EndProcedure
	Macro ReceiveHTTPMemory(Url, Flags = 0, Callback = 0)
		__ReceiveHTTPMemory(Url, Flags, Callback)
	EndMacro
	
	Procedure GetAjaxSetup(Key.s)
	EndProcedure
	
	Procedure SetAjaxSetup(Key.s, Value)
	EndProcedure	
	
	Enumeration 
		
		; Websocket
		
		#PB_Event_Websocket_OnOpen
		#PB_Event_Websocket_OnClose	
		#PB_Event_Websocket_OnMessage
		#PB_Event_Websocket_OnError
		
		; Movie
		
		#PB_Event_Movie_Abort
		#PB_Event_Movie_CanPlay
		#PB_Event_Movie_CanPlayThrough
		#PB_Event_Movie_DurationChange
		#PB_Event_Movie_Emptied
		#PB_Event_Movie_Ended
		#PB_Event_Movie_Error
		#PB_Event_Movie_LoadedData
		#PB_Event_Movie_LoadedMetaData
		#PB_Event_Movie_LoadStart
		#PB_Event_Movie_Pause
		#PB_Event_Movie_Play
		#PB_Event_Movie_Playing
		#PB_Event_Movie_Progress
		#PB_Event_Movie_RateChange
		#PB_Event_Movie_Seeked
		#PB_Event_Movie_Seeking
		#PB_Event_Movie_Stalled
		#PB_Event_Movie_Suspend
		#PB_Event_Movie_TimeUpdate
		#PB_Event_Movie_VolumeChange
		#PB_Event_Movie_Waiting
		
		#PB_Movie_ShowControls
		#PB_Movie_Position
		#PB_Movie_Length
		#PB_Movie_Volume
		
		; Music
		
		#PB_Event_Music_Abort
		#PB_Event_Music_CanPlay
		#PB_Event_Music_CanPlayThrough
		#PB_Event_Music_DurationChange
		#PB_Event_Music_Emptied
		#PB_Event_Music_Ended
		#PB_Event_Music_Error
		#PB_Event_Music_LoadedData
		#PB_Event_Music_LoadedMetaData
		#PB_Event_Music_LoadStart
		#PB_Event_Music_Pause
		#PB_Event_Music_Play
		#PB_Event_Music_Playing
		#PB_Event_Music_Progress
		#PB_Event_Music_RateChange
		#PB_Event_Music_Seeked
		#PB_Event_Music_Seeking
		#PB_Event_Music_Stalled
		#PB_Event_Music_Suspend
		#PB_Event_Music_TimeUpdate
		#PB_Event_Music_VolumeChange
		#PB_Event_Music_Waiting
		
		#PB_Music_ShowControls
		#PB_Music_Position
		#PB_Music_Length
		#PB_Music_Volume	  
		
		; Upload
		
		#PB_Event_Upload_BeforeSend
		#PB_Event_Upload_UploadProgress
		#PB_Event_Upload_Success
		#PB_Event_Upload_Complete
		#PB_Event_Upload_Error
		
		; StringGadget
		
		#PB_String_AllowedChars
		
		#PB_String_Autocomplete_Datasource
		#PB_String_Autocomplete_MinLength
		
		#PB_String_Center
		#PB_String_Color
		#PB_String_Date
		#PB_String_DateTime
		#PB_String_DateTimeLocal
		#PB_String_Email
		#PB_String_IsValid
		#PB_String_Left
		#PB_String_Month
		#PB_String_Number
		#PB_String_Pattern
		#PB_String_Placeholder
		#PB_String_Range
		#PB_String_Required
		#PB_String_Right
		#PB_String_Search
		#PB_String_Tel
		#PB_String_Time
		#PB_String_Type
		#PB_String_Url
		#PB_String_Week
		
		#PB_EventType_KeyPress
		
		#PB_PanelGadget_Sortable
		#PB_PanelGadget_Closable
		
		#PB_FlipSwitch_On
		#PB_FlipSwitch_Off
		
		; Mobile
		
		#PB_Widget_Html
		#PB_Widget_LabelText
		#PB_Widget_LabelHtml
		
		#PB_Widget_Minimum
		#PB_Widget_Maximum
		#PB_Widget_Step
		#PB_Widget_Value
		
		#PB_Widget_Corners
		#PB_Widget_Icon
		#PB_Widget_IconPosition
		#PB_Widget_Position
		#PB_Widget_Inline
		#PB_Widget_Mini
		#PB_Widget_Shadow
		#PB_Widget_Theme
		#PB_Widget_ClearButton
		#PB_Widget_ClearButtonText
		#PB_Widget_Role
		#PB_Widget_InputType
		#PB_Widget_ExcludeInvisible
		#PB_Widget_Type
		
		; Swipe & Co
		
		#PB_EventType_Swipe
		; #PB_EventType_Tap
		;	#PB_EventType_DoubleTap
		;	#PB_EventType_LongTap
		
		#PB_Gadget_Color
		#PB_Gadget_BorderColor
		
		; ListIconGadget
		
		#PB_ListIcon_Sortable
		#PB_ListIcon_Resizable
		#PB_ListIcon_Editable
		#PB_ListIcon_ColumnDelimiter
		#PB_ListIcon_RecordDelimiter
		#PB_ListIcon_CustomRenderer
		#PB_ListIcon_Columns
		#PB_ListIcon_Records
		#PB_ListIcon_SearchFields
		#PB_ListIcon_HeaderText
		#PB_ListIcon_URL
		#PB_ListIcon_Changed
		#PB_ListIcon_Header							; header         : false,  // indicates if header is visible
		#PB_ListIcon_Toolbar						; toolbar        : false,  // indicates if toolbar is visible
		#PB_ListIcon_Footer							; footer         : false,  // indicates if footer is visible
		#PB_ListIcon_ColumnHeaders			; columnHeaders  : true,   // indicates if columns is visible
		#PB_ListIcon_LineNumbers				; lineNumbers    : false,  // indicates if line numbers column is visible
		#PB_ListIcon_ExpandColumn				; expandColumn   : false,  // indicates if expand column is visible
		#PB_ListIcon_SelectColumn				; selectColumn   : false,  // indicates if select column is visible
		#PB_ListIcon_EmptyRecords				; emptyRecords   : true,   // indicates if empty records are visible
		#PB_ListIcon_ToolbarReload			; toolbarReload  : true,   // indicates if toolbar reload button is visible
		#PB_ListIcon_ToolbarColumns			; toolbarColumns : true,   // indicates if toolbar columns button is visible
		#PB_ListIcon_ToolbarSearch			; toolbarSearch  : true,   // indicates if toolbar search controls are visible
		#PB_ListIcon_ToolbarAdd					; toolbarAdd     : true,   // indicates if toolbar add new button is visible
		#PB_ListIcon_ToolbarEdit				; toolbarEdit    : true,   // indicates if toolbar edit button is visible
		#PB_ListIcon_ToolbarDelete			; toolbarDelete  : true,   // indicates if toolbar delete button is visible
		#PB_ListIcon_ToolbarSave				; toolbarSave    : true,   // indicates if toolbar save button is visible
		#PB_ListIcon_SelectionBorder		; selectionBorder: true,   // display border arround selection (for selectType = 'cell')
		#PB_ListIcon_RecordTitles				; recordTitles   : true,   // indicates if to define titles for records
		#PB_ListIcon_SkipRecords				; skipRecords    : true    // indicates if skip records should be visible
		#PB_ListIcon_SelectTypeCell
		
		#PB_ListIcon_Alignment
		#PB_ListIcon_Align_Left
		#PB_ListIcon_Align_Right
		#PB_ListIcon_Align_Center
		
		#PB_EventType_Select
		#PB_EventType_Unselect
		
		#PB_Spin_Step
		
		; additional TypeOf-Constants:
		
		#PB_Undefined
		#PB_Boolean
		#PB_Number
		#PB_Symbol
		#PB_Object
		#PB_Unknown
		
		#P2W_ServerPath
		#P2W_MetaTags
		
		#PB_Event_BatteryStatus
		
		#PB_Text_Middle
		#PB_Text_Rounded_Corners
		
		#PB_ComboBox_MaxHeight
		
		#PB_Event_SizeWindowStart
		#PB_Event_SizeWindowStop
		
		#PB_ComboBox_Simple
		
	EndEnumeration
	
	Global P2W_CGI_HeaderContentType.s
	Structure sCGIParameter
		Name.s
		Value.s
		Type.i
		Data.i
		DataSize.i
	EndStructure
	Global NewMap CGIParameter.sCGIParameter()	
	
P2W_Converter_End_Comment

; Global P2W_End

; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 132
; FirstLine = 90
; Folding = Hw-PAAwD1BAAAAAAAAAAAAA--AAAAAAAAA9-
; EnableXP