XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

InitNetwork()

; ---------------------
; GetHTTPHeader()
; ---------------------

; Header$ = GetHTTPHeader("http://www.purebasic.com/index.php3")
; 
; Repeat
; 	Index + 1
; 	Line$ = StringField(Header$, Index, #LF$)
; 	Debug Line$
; Until Line$ = ""

; ---------------------
; GetURLPart()
; ---------------------

; URL$ = "http://user:pass@www.purebasic.com:80/index.php3?test=1&ok=2"
; 
; Debug GetURLPart(URL$, #PB_URL_Protocol)   ; Will print "http"
; Debug GetURLPart(URL$, #PB_URL_Site)		   ; Will print "www.purebasic.com"
; Debug GetURLPart(URL$, #PB_URL_Port)		   ; Will print "80"
; Debug GetURLPart(URL$, #PB_URL_Parameters) ; Will print "test=1&ok=2"
; Debug GetURLPart(URL$, #PB_URL_Path)			 ; Will print "index.php3"
; Debug GetURLPart(URL$, #PB_URL_User)			 ; Will print "user"
; Debug GetURLPart(URL$, #PB_URL_Password)	 ; Will print "pass"
; Debug GetURLPart(URL$, "test")						 ; Will print "1"
; Debug GetURLPart(URL$, "ok")							 ; Will print "2"

; ---------------------
; ReceiveHTTPFile
; ---------------------

; Filename$ = SaveFileRequester("Where to save index.php3 ?", "", "", 0)
; 
; If ReceiveHTTPFile("http://www.purebasic.com/index.php3", Filename$)
; 	Debug "Success"
; Else
; 	Debug "Failed"
; EndIf

; ---------------------
; SetURLPart()
; ---------------------

; URL$ = "http://www.test.com/hello.php3"
; 
; URL$ = SetURLPart(URL$, #PB_URL_Protocol, "ftp")
; URL$ = SetURLPart(URL$, #PB_URL_Site, "www.purebasic.com")
; URL$ = SetURLPart(URL$, #PB_URL_Port, "80")
; URL$ = SetURLPart(URL$, #PB_URL_Path, "english/index.php3")
; URL$ = SetURLPart(URL$, #PB_URL_User, "user")
; URL$ = SetURLPart(URL$, #PB_URL_Password, "pass")
; URL$ = SetURLPart(URL$, "test", "1")
; URL$ = SetURLPart(URL$, "ok", "2")
; 
; Debug URL$ ; Will print "ftp://user:pass@www.purebasic.com:80/english/index.php3?test=1&ok=2"

; ---------------------
; URLDecoder()
; ---------------------

Debug URLDecoder("http://www.purebasic.com/test%20with%20space.php3")
; Will print "http://www.purebasic.com/test with space.php3"

; ---------------------
; URLEncoder()
; ---------------------

Debug URLEncoder("http://www.purebasic.com/test with space.php3")
; Will print "http://www.purebasic.com/test%20with%20space.php3"


; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 38
; FirstLine = 23
; EnableXP