﻿XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Debug "----"
Debug "InsertJSONList():"
Debug "----"

NewList Names.s()
AddElement(Names()): Names() = "John"
AddElement(Names()): Names() = "Jane"
AddElement(Names()): Names() = "Jim"

CreateJSON(0)
InsertJSONList(JSONValue(0), Names())
Debug ComposeJSON(0, #PB_JSON_PrettyPrint)


Debug "----"
Debug "InsertJSONMap():"
Debug "----"

NewMap Colors()
Colors("red")   = 65280
Colors("green") = 255
Colors("blue")  = 16711680

CreateJSON(0)
InsertJSONMap(JSONValue(0), Colors())
JSONMap_Colors.s = ComposeJSON(0, #PB_JSON_PrettyPrint)
Debug JSONMap_Colors

Debug "-----"
Debug "ExtractJSONMap():"
Debug "-----"

ParseJSON(0, JSONMap_Colors)
NewMap NewColors()
ExtractJSONMap(JSONValue(0), NewColors())
ForEach NewColors()
	Debug MapKey(NewColors()) + ": " + Str(NewColors())
Next

Debug "----"
Debug "InsertJSONArray():"
Debug "----"

Dim ColorArray.s(3)
ColorArray(0) = "red"
ColorArray(1) = "yellow"
ColorArray(2) = "green"
ColorArray(3) = "blue"

CreateJSON(0)
InsertJSONArray(JSONValue(0), ColorArray())
Define JSONArray_Colors.s  = ComposeJSON(0)
Debug JSONArray_Colors

Debug "----"
Debug "ExtractJSONArray():"
Debug "----"

; ParseJSON(0, "[1, 3, 5, 7, 9]")

ParseJSON(0, JSONArray_Colors)

Dim a(0)
ExtractJSONArray(JSONValue(0), a())

For i = 0 To ArraySize(a())
	Debug a(i)
Next i

Debug "##########################"

ParseJSON(0, "[[0, 1, 2], [3, 4, 5], [6, 7, 8]]")

Dim b(0, 0)
ExtractJSONArray(JSONValue(0), b())

For x = 0 To 2
	For y = 0 To 2
		Debug b(x, y)
	Next y
Next x


; IDE Options = PureBasic 5.31 Beta 1 (Windows - x86)
; CursorPosition = 4
; EnableUnicode
; EnableXP