XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration ; Windows
	#frmMain
EndEnumeration

Enumeration ; Shortcuts
	#scLeft
	#scRight
	#scUp
	#scDown
	#scReturn
	#scF1
	#scW
	#scA
	#scS
	#scD
EndEnumeration

OpenWindow(#frmMain, 0, 0, 0, 0, "AddKeyboardShortcut()-Test", #PB_Window_BorderLess | #PB_Window_Maximize)

Debug("Please press any Arrow-Key, 'W', 'A', 'S', 'D', 'Return' or 'F1'")

Procedure KeyboardEvent()
  
  Protected EventType.s = ""
  
  Select EventType()
    Case #PB_EventType_KeyDown  : EventType = " (down)"
    Case #PB_EventType_KeyUp    : EventType = " (up)"
  	Default                     : EventType = " (???)"
  EndSelect
  
	Select EventMenu()
		Case #scLeft   : Debug "Left"   + EventType
		Case #scRight  : Debug "Right"  + EventType
		Case #scUp     : Debug "Up"     + EventType
		Case #scDown   : Debug "Down"   + EventType
		Case #scReturn : Debug "Return" + EventType
		Case #scF1     : Debug "F1"     + EventType
		Case #scW      : Debug "W"      + EventType
		Case #scA      : Debug "A"      + EventType
		Case #scS      : Debug "S"      + EventType
		Case #scD      : Debug "S"      + EventType
		Default        : Debug "?"      + EventType
	EndSelect
	
EndProcedure

AddKeyboardShortcut(#frmMain, #PB_Shortcut_Left,   #scLeft)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_Right,  #scRight)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_Up,     #scUp)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_Down,   #scDown)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_Return, #scReturn)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_F1,     #scF1)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_W,      #scW)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_A,      #scA)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_S,      #scS)
AddKeyboardShortcut(#frmMain, #PB_Shortcut_D,      #scD)

BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scLeft, #PB_EventType_KeyDown)
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scRight, #PB_EventType_KeyUp)
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scUp, #PB_All) ; similar to KeyDown | KeyUp 
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scDown) ; without EventType: similar to KeyDown | KeyUp 
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scReturn)
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scF1)
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scW)
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scA)
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scS)
BindEvent(#PB_Event_Menu, @KeyboardEvent(), #frmMain, #scD)





; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 23
; FirstLine = 22
; Folding = -
; EnableXP