﻿XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration FormWindow
	#frmMain
EndEnumeration

Enumeration FormGadget
	#lblTheme
	#lstTheme
	#Button_0
	#Calendar_0
	#Date_0
	#ProgressBar_0
	#Spin_0
	#Option_0
	#Option_1
	#Option_2
	#Checkbox_0
	#Checkbox_1
	#Checkbox_2
	#Combo_0
	#Button_1
	#Button_2
	#Tree_0
EndEnumeration

#myTimer = 1

Procedure OpenfrmMain(x = 0, y = 0, width = 1020, height = 720)
	
	OpenWindow(#frmMain, x, y, width, height, "ChangeTheme", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	TextGadget(#lblTheme, 10, 10, 290, 25, "Select a theme:")
	ListViewGadget(#lstTheme, 10, 40, 290, 420)
	CalendarGadget(#Calendar_0, 730, 40, 240, 200, 0, #PB_Calendar_Borderless)
	DateGadget(#Date_0, 730, 290, 240, 25, "")
	ProgressBarGadget(#ProgressBar_0, 520, 160, 150, 25, 0, 100)
	SpinGadget(#Spin_0, 520, 260, 150, 25, 0, 100)
	
	OptionGadget(#Option_0, 340, 40, 150, 25, "Option 1")
	SetGadgetState(#Option_0, 1)
	OptionGadget(#Option_1, 340, 70, 150, 25, "Option 2")
	OptionGadget(#Option_2, 340, 100, 150, 25, "Option 3")
	
	CheckBoxGadget(#Checkbox_0, 340, 150, 150, 25, "Checkbox 1")
	SetGadgetState(#Checkbox_0, #PB_Checkbox_Checked)
	CheckBoxGadget(#Checkbox_1, 340, 180, 150, 25, "Checkbox 2")
	CheckBoxGadget(#Checkbox_2, 340, 210, 150, 25, "Checkbox 3")
	
	ComboBoxGadget(#Combo_0, 520, 330, 150, 25)
	AddGadgetItem(#Combo_0, -1, "Combobox Item 1")
	AddGadgetItem(#Combo_0, -1, "Combobox Item 2")
	AddGadgetItem(#Combo_0, -1, "Combobox Item 3")
	
	ButtonGadget(#Button_0, 520, 40, 150, 25, "ButtonGadget 1")
	ButtonGadget(#Button_1, 520, 70, 150, 25, "ButtonGadget 2")
	ButtonGadget(#Button_2, 520, 100, 150, 25, "ButtonGadget 3")
	
	TreeGadget(#Tree_0, 360, 390, 400, 300)
	AddGadgetItem (#Tree_0, -1, "Normal Item", 0, 0)
	AddGadgetItem (#Tree_0, -1, "Node", 0, 0) 
	AddGadgetItem(#Tree_0, -1, "Sub-Item 1", 0, 1)
	AddGadgetItem(#Tree_0, -1, "Sub-Item 2", 0, 1)
	AddGadgetItem(#Tree_0, -1, "Sub-Item 3", 0, 1)
	AddGadgetItem(#Tree_0, -1, "Sub-Item 4", 0, 1)
	AddGadgetItem (#Tree_0, -1, "File", 0, 0)
	
EndProcedure

Procedure ThemeChanger()
	
	Protected SelectedTheme.s = GetGadgetText(#lstTheme)
	
	SetTheme(SelectedTheme)
	
EndProcedure

Procedure TimerEvent()
	
	Protected ProgressBarGadgetValue
	
	ProgressBarGadgetValue = GetGadgetState(#ProgressBar_0)
	
	ProgressBarGadgetValue + 1
	
	If ProgressBarGadgetValue = 101
		ProgressBarGadgetValue = 0
	EndIf
	
	SetGadgetState(#ProgressBar_0, ProgressBarGadgetValue)
	
EndProcedure

Procedure CloseWindowEvent()
	
	RemoveWindowTimer(#frmMain, #myTimer)
	
EndProcedure

OpenfrmMain()

AddGadgetItem(#lstTheme, -1, "black-tie")
AddGadgetItem(#lstTheme, -1, "blitzer")
AddGadgetItem(#lstTheme, -1, "cupertino")
AddGadgetItem(#lstTheme, -1, "dark-hive")
AddGadgetItem(#lstTheme, -1, "dot-luv")
AddGadgetItem(#lstTheme, -1, "eggplant")
AddGadgetItem(#lstTheme, -1, "excite-bike")
AddGadgetItem(#lstTheme, -1, "flick")
AddGadgetItem(#lstTheme, -1, "hot-sneaks")
AddGadgetItem(#lstTheme, -1, "humanity")
AddGadgetItem(#lstTheme, -1, "le-frog")
AddGadgetItem(#lstTheme, -1, "mint-choc")
AddGadgetItem(#lstTheme, -1, "overcast")
AddGadgetItem(#lstTheme, -1, "pepper-grinder")
AddGadgetItem(#lstTheme, -1, "redmond")
AddGadgetItem(#lstTheme, -1, "smoothness")
AddGadgetItem(#lstTheme, -1, "south-street")
AddGadgetItem(#lstTheme, -1, "start")
AddGadgetItem(#lstTheme, -1, "sunny")
AddGadgetItem(#lstTheme, -1, "swanky-purse")
AddGadgetItem(#lstTheme, -1, "trontastic")
AddGadgetItem(#lstTheme, -1, "ui-darkness")
AddGadgetItem(#lstTheme, -1, "ui-lightness")
AddGadgetItem(#lstTheme, -1, "vader")


SetGadgetItemState(#Tree_0, 2, #PB_Tree_Expanded)

BindGadgetEvent(#lstTheme, @ThemeChanger())


AddWindowTimer(#frmMain, #myTimer, 200)

BindEvent(#PB_Event_Timer, @TimerEvent(), #frmMain, #myTimer)

BindEvent(#PB_Event_CloseWindow, @CloseWindowEvent(), #frmMain)

; IDE Options = PureBasic 5.40 LTS Beta 8 (Windows - x86)
; CursorPosition = 73
; Folding = 5-
; EnableUnicode
; EnableXP