EnableExplicit

XIncludeFile "..\..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration 
	#Desktop
	#Image
	#ImageGadget
	#InfoLabel
EndEnumeration

P2W_SetDesktopID(#Desktop)

SetWindowColor(#Desktop, RGB(0,0,0))

TextGadget(#InfoLabel, 10, 10, 600, 30, "Ready")

SetGadgetColor(#InfoLabel, #PB_Gadget_FrontColor, RGB(255, 255, 255))

Declare ImageLoadCallback(LoadedImage)

Procedure Hidden()
	
	SetGadgetText(#InfoLabel, "Hidden()")
	
	SetGadgetText(#InfoLabel, "Loading random picture...")
	
	LoadImage(#ImageGadget, "rndflickrpic.php?rnd=" + Str(ElapsedMilliseconds()), 0, @ImageLoadCallback())
	
EndProcedure

Procedure Shown()
	
	SetGadgetText(#InfoLabel, "Shown()")
	
	HideGadget(#ImageGadget, #True, 2000, @Hidden())
	
EndProcedure

Procedure SetGadgetStateCallback()
	
	SetGadgetText(#InfoLabel, "SetGadgetStateCallback()")
	
	ResizeGadget(#ImageGadget, 
	             (WindowWidth(#Desktop) - ImageWidth(#Image)) / 2,
	             (WindowHeight(#Desktop) - ImageHeight(#Image)) / 2,
	             ImageWidth(#Image),
	             ImageHeight(#Image))
	
	HideGadget(#ImageGadget, #False, 2000, @Shown())
	
EndProcedure

Procedure ImageLoadCallback(LoadedImage)
	
	SetGadgetText(#InfoLabel, "ImageLoadCallback()")
	
	ImageGadget(#ImageGadget, 0, 0, 0, 0, 0)
	
	HideGadget(#ImageGadget, #True)
	
	SetGadgetState(#ImageGadget, LoadedImage, @SetGadgetStateCallback())
	
EndProcedure

SetGadgetText(#InfoLabel, "Loading random picture...")

LoadImage(#Image, "rndflickrpic.php", 0, @ImageLoadCallback())

DataSection
	IncludeBinary "rndflickrpic.php"
EndDataSection

; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 1
; Folding = x-
; EnableXP