XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

Procedure GetCurrentPosition_Success(coords.s)
  
  Protected  Latitude.s         = "Latitude: "         + StringField(coords, 1, ";") ; The latitude as a decimal number
  Protected  Longitude.s        = "Longitude: "        + StringField(coords, 2, ";") ; The longitude as a decimal number
  Protected  Accuracy.s         = "Accuracy: "         + StringField(coords, 3, ";") ; The accuracy of position
  Protected  Altitude.s         = "Altitude: "         + StringField(coords, 4, ";") ; The altitude in meters above the mean sea level
  Protected  AltitudeAccuracy.s = "AltitudeAccuracy: " + StringField(coords, 5, ";") ; The altitude accuracy of position
  Protected  Heading.s          = "Heading: "          + StringField(coords, 6, ";") ; The heading as degrees clockwise from North
  Protected  Speed.s            = "Speed: "            + StringField(coords, 7, ";") ; The speed in meters per second
  Protected  Timestamp.s        = "Timestamp: "        + StringField(coords, 8, ";") ; The date/time of the response  
  
  MessageRequester("Yay!",
                   Latitude + #CRLF$ +
                   Longitude + #CRLF$ +
                   Accuracy + #CRLF$ +
                   Altitude + #CRLF$ +
                   AltitudeAccuracy + #CRLF$ +
                   Heading + #CRLF$ +
                   Speed + #CRLF$ +
                   Timestamp)
  
EndProcedure

Procedure GetCurrentPosition_Error(Error.s)
  
  MessageRequester("What a pity!", Error)
  
EndProcedure

P2W_Geolocation_GetCurrentPosition(@GetCurrentPosition_Success(), @GetCurrentPosition_Error())

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 29
; Folding = -
; EnableXP