﻿XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

EnableCGI ; the whole CGI-Code is encapsulated with EnableCGI / DisableCGI

UseSQLiteDatabase()

Procedure.s Test()
	ProcedureReturn "Test"
EndProcedure

ProcedureDLL.s TestDatabase()
	
	Protected ReturnValue.s
	Protected DB
	
	DB = OpenDatabase(0, ":memory:", "", "")
	
	If DB
		ReturnValue = Test() + " OpenDatabase(): Success"
	Else
		ReturnValue = Test() + " OpenDatabase(): Failed"
	EndIf
	
	ProcedureReturn ReturnValue
	
EndProcedure

ProcedureDLL.s Test_Plain()
	
	Protected ReturnValue.s
	
	; P2W_CGI_HeaderContentType is a global variable to set
	; the type of the content returned by the CGI
	
	P2W_CGI_HeaderContentType = "text/plain;charset=iso-8859-1"
	
	ReturnValue = "HelloFromTest (plain)"
	
	ProcedureReturn ReturnValue
	
EndProcedure

ProcedureDLL.s Test_Html()
	
	Protected ReturnValue.s
	
	; P2W_CGI_HeaderContentType is a global variable to set
	; the type of the content returned by the CGI
	
	P2W_CGI_HeaderContentType = "text/html;charset=iso-8859-1"
	
	ReturnValue = "HelloFromTest (html)"
	
	ProcedureReturn ReturnValue
	
EndProcedure

DisableCGI

Debug TestDatabase()
Debug Test_Plain()
Debug Test_Html()
Debug Test_Plain()

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableUnicode
; EnableXP