﻿XIncludeFile "..\p2w.pbi"

EnableExplicit

Procedure SpinGadgetEvent()
	
	Select EventType()
		Case #PB_EventType_Change
			Debug "EventType(): PB_EventType_Change"
		Case #PB_EventType_Up
			Debug "EventType(): PB_EventType_Up"
		Case #PB_EventType_Down
			Debug "EventType(): PB_EventType_Down"
		Default
			Debug "EventType(): " + Str(EventType()) + " (???)"
	EndSelect
	
EndProcedure

OpenWindow(0, 0, 0, 140, 70, "SpinGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

SpinGadget(0, 20, 20, 100, 25, -10, 10)

; SetGadgetAttribute(0, #PB_Spin_Step, 0.001)

; The following events are supported through EventType(): 
;  #PB_EventType_Change: The text in the edit area has been modified by the user.
;  #PB_EventType_Up    : The 'Up' button was pressed.
;  #PB_EventType_Down  : The 'Down' button was pressed.

BindGadgetEvent(0, @SpinGadgetEvent(), #PB_EventType_Change)
BindGadgetEvent(0, @SpinGadgetEvent(), #PB_EventType_Up)
BindGadgetEvent(0, @SpinGadgetEvent(), #PB_EventType_Down)

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 28
; Folding = -
; EnableUnicode
; EnableXP