XIncludeFile "..\p2w.pbi"

EnableExplicit

Procedure ToolbarButton_0_Event()
	Debug "ToolbarButton_0 clicked"
EndProcedure

Procedure ToolbarButton_1_Event()
	Debug "ToolbarButton_1 clicked"
EndProcedure

Procedure ToolbarButton_2_Event()
	Debug "ToolbarButton_2 clicked"
EndProcedure

Procedure ToolbarButton_3_Event()
	Debug "ToolbarButton_3 (custom icon) clicked"
EndProcedure

Enumeration
	#myWindow
	#myToolbar
	#ToolbarButton_0
	#ToolbarButton_1
	#ToolbarButton_2
	#ToolbarButton_3
EndEnumeration

OpenWindow(#myWindow, #PB_Ignore, #PB_Ignore, 200, 100, 
           "ToolBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

CreateToolBar(#myToolbar, WindowID(#myWindow))

ToolBarStandardButton(#ToolbarButton_0, #PB_ToolBarIcon_New)
ToolBarToolTip(#myToolbar, #ToolbarButton_0, "New")

ToolBarStandardButton(#ToolbarButton_1, #PB_ToolBarIcon_Open)
ToolBarToolTip(#myToolbar, #ToolbarButton_1, "Open")

ToolBarStandardButton(#ToolbarButton_2, #PB_ToolBarIcon_Save)
ToolBarToolTip(#myToolbar, #ToolbarButton_2, "Save")

ToolBarSeparator()

; Custom icon:
; Overview: http://api.jqueryui.com/theming/icons/

ToolBarStandardButton(#ToolbarButton_3, @"ui-icon-star")
ToolBarToolTip(#myToolbar, #ToolbarButton_3, "Custom icon")

BindEvent(#PB_Event_Menu, @ToolbarButton_0_Event(), #myWindow, #ToolbarButton_0)
BindEvent(#PB_Event_Menu, @ToolbarButton_1_Event(), #myWindow, #ToolbarButton_1)
BindEvent(#PB_Event_Menu, @ToolbarButton_2_Event(), #myWindow, #ToolbarButton_2)
BindEvent(#PB_Event_Menu, @ToolbarButton_3_Event(), #myWindow, #ToolbarButton_3)


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableXP