﻿EnableExplicit

Enumeration
	#CodeButton = 100
	#CodeWindow = 101
	#AceEditor = 102
EndEnumeration

Procedure ShowCode()
	
	! $.when( $.getScript('https://cdnjs.cloudflare.com/ajax/libs/ace/1.1.9/ace.js'), $.ready ).done(function(){

	OpenWindow(#CodeWindow, #PB_Ignore, #PB_Ignore, 640, 480, "Code", #PB_Window_ScreenCentered | #PB_Window_SystemMenu)
	
	AceEditorGadget(#AceEditor, 10, 10, 620, 460, #PB_AceEditor_Border)
	SetGadgetItemText(#AceEditor, #PB_AceEditor_Theme, "eclipse")
	SetGadgetItemText(#AceEditor, #PB_AceEditor_Mode, "vbscript")  
	
	Protected Code.s = LoadTextfile("AccordionGadget.pb")
	
	Code = StringField(Code, 1, "XIncludeFile(" + Chr(34) + "AccordionGadget_ShowCode.pb")
	
	SetGadgetText(#AceEditor, Code)
	
	! });
	
EndProcedure

ButtonGadget(#CodeButton, 400, 10, 200, 30, "Show PB-Code")
BindGadgetEvent(#CodeButton, @ShowCode())

DataSection
	IncludeBinary "AccordionGadget.pb"
EndDataSection

; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 1
; Folding = -
; EnableUnicode
; EnableXP