; Vis-Gadget

EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\VisGadget\VisGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#myVisGadget
	#cmdRePopulate
	#cmdClear
EndEnumeration

Procedure RePopulate()
	
	; add nodes
	
	VisGadget_AddNode(#myVisGadget, "Sun", "Sun")
	VisGadget_AddNode(#myVisGadget, "Mercury", "Mercury")
	VisGadget_AddNode(#myVisGadget, "Venus", "Venus")
	VisGadget_AddNode(#myVisGadget, "Earth", "Earth")
	VisGadget_AddNode(#myVisGadget, "Mars", "Mars")
	VisGadget_AddNode(#myVisGadget, "Jupiter", "Jupiter")
	VisGadget_AddNode(#myVisGadget, "Saturn", "Saturn")
	VisGadget_AddNode(#myVisGadget, "Uranus", "Uranus")
	VisGadget_AddNode(#myVisGadget, "Neptun", "Neptune")
	
	; add edges
	
	VisGadget_AddEdge(#myVisGadget, "Sun", "Mercury")
	VisGadget_AddEdge(#myVisGadget, "Sun", "Venus")
	VisGadget_AddEdge(#myVisGadget, "Sun", "Earth")
	VisGadget_AddEdge(#myVisGadget, "Sun", "Mars")
	VisGadget_AddEdge(#myVisGadget, "Sun", "Jupiter")
	VisGadget_AddEdge(#myVisGadget, "Sun", "Saturn")
	VisGadget_AddEdge(#myVisGadget, "Sun", "Uranus")
	VisGadget_AddEdge(#myVisGadget, "Sun", "Neptune")
	
EndProcedure

Procedure ClearNodesAndEdges()
	
	VisGadget_ClearNodes(#myVisGadget)
	VisGadget_ClearEdges(#myVisGadget)
	
EndProcedure

VisGadget(#myVisGadget, 10, 50, 800, 800, #PB_Vis_Border)

ButtonGadget(#cmdRePopulate, 10, 10, 300, 30, "(Re-)Populate")
ButtonGadget(#cmdClear, 320, 10, 300, 30, "Clear nodes and edges")

BindGadgetEvent(#cmdRePopulate, @RePopulate())
BindGadgetEvent(#cmdClear, @ClearNodesAndEdges())
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 41
; Folding = 5
; EnableXP