﻿; XIncludeFile "p2w.pbi"

; Column-Structure: http://w2ui.com/web/docs/w2grid.columns

Structure s_ListIcon_Column    ; column = {
	caption.s								 ;     caption        : '',     // column caption 
	field.s									 ;     field          : '',     // field name to map column to a record
	size.s									 ;     size           : null,   // size of column in px or %
	min.s										 ;     min            : 15,     // minimum width of column in px
	max.s										 ;     max            : null,   // maximum width of column in px
	gridMinWidth.s					 ;     gridMinWidth   : null,   // minimum width of the grid when column is visible
	sizeCorrected.s					 ;     sizeCorrected  : null,   // read only, corrected size (see explanation below)
	sizeCalculated.s				 ;     sizeCalculated : null,   // read only, size in px (see explanation below)
	hidden.i								 ;     hidden         : false,  // indicates if column is hidden
	sortable.i							 ;     sortable       : false,  // indicates if column is sortable
	searchable.i						 ;     searchable     : false,  // indicates if column is searchable, bool/string: int,float,date,...
	resizable.i							 ;     resizable      : true,   // indicates if column is resiable
	hideable.i							 ;     hideable       : true,   // indicates if column can be hidden
	attr.s									 ;     attr           : '',     // string that will be inside the <td ... attr> tag
	style.s									 ;     style          : '',     // additional style for the td tag
	render.i                 ;     render         : null,   // string or render function
	title.s									 ;     title          : null,   // string or function for the title property for the column cells
	editable.i							 ;     editable       : {}      // editable object if column fields are editable
EndStructure							 ; }

; Search-Structure: http://w2ui.com/web/docs/w2grid.searches

Structure s_ListIcon_Search ; search = {
	type.s								;     type     : 'text',    // type of the search (see below)
	field.s								;     field    : '',        // field name to submit to server
	caption.s							;     caption  : '',        // caption of the search
	inTag.s								;     inTag    : '',        // text that will be inside <input ...> tag
	outTag.s							;     outTag   : '',        // text that will be outside <input ...> tag
	hidden.s							;     hidden   : false,     // indicates if search is show or hidden
  ; options.s           ;     options  : {}         // options for w2field object
EndStructure						; }


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 27
; Folding = -
; EnableUnicode
; EnableXP